#  Copyright (C) 2004 Koji Tsukada
#      All rights reserved.
#      This is free software with ABSOLUTELY NO WARRANTY.
#
#  You can redistribute it and/or modify it under the terms of
#  the GNU General Public License version 2.

module BarcodeReview
  #o[R[h֘Å{IȏsNX
  class Barcode 
    #o[R[h
    class Type
      ISBN =  "ISBN"
      UPC =   "UPC"
      EAN =   "EAN"
      OTHER=  "OTHER"
    end
      
    attr_reader(:is_ready, :type, :barcode)

    #RXgN^
    def initialize(barcode)
      @barcode = barcode.to_s
      correct_zero()
      @type = check_type()
    end
    
    #00Ŏn܂o[R[hԍC
    def correct_zero
      if(@barcode.match(/^00/) && @barcode.length > 12)
        @barcode = @barcode.slice(1, @barcode.length-1)
        return true
      else
        return false
      end
    end
    
    #o[R[hʂ𔻒
    def check_type
      if(@barcode.match(/^978/))
        decode_isbn()
        return Type::ISBN
      else
        if(@barcode.length == 12)
          return Type::UPC
        elsif(@barcode.length == 13)
          return Type::EAN
        elsif(@barcode.length == 10)
          decode_isbn()
          return Type::ISBN
        else
          return Type::OTHER
        end
      end
    end

    #ISBNo[R[h̃wb_菜C`FbNTČvZD
    def decode_isbn()
      if(@barcode.match(/^978/))
        @barcode = @barcode.slice(3,9)
      else
        @barcode = @barcode.slice(0,9)
      end
      
      sum = 0
      checksum = 0
      
      for i in 0...9
        sum = sum + (@barcode.slice(i,1).to_i * (i+1))
      end
        
      checksum = sum % 11
        
      if(checksum == 10)
        @barcode = @barcode + "X"
      else
        @barcode = @barcode + checksum.to_s
      end
    end
  end
end


