#!/usr/local/bin/ruby

#  Copyright (C) 2004 Koji Tsukada
#      All rights reserved.
#      This is free software with ABSOLUTELY NO WARRANTY.
#
#  You can redistribute it and/or modify it under the terms of
#  the GNU General Public License version 2.

require "net/smtp"
require "mailread"

module BarcodeReview
  #BarcodeReviewΥᥤ󥯥饹
  class BarcodeReview
    
    ########################桼꤬ɬפ########################
    #ǥХåå˽Ϥ뤫(ưƥȻʳfalse侩)
    DEBUG = true
    #ɤEUCξ"e", SJISξ"s"򥻥å. 
    $KCODE = "e"
    #ưϤ뤫
    LOGGING = true

    #BarcodeReviewưǥ쥯ȥ
    PROGRAM_DIRECTORY = "/home/br/barcodereview"
    
    #Aassociate ID
    AMAZON_ID = ""
    #AWS subscription ID 
    AMAZON_TOKEN = ""  

    #SMTP̾
    SMTP_SERVER = "rcode.jp" 
    #BarcodeReviewư륵̾.
    SMTP_HELO = "rcode.jp"
    #smtpauthuser & passwordꡥѤʤ϶ʸ""
    SMTP_USER = ""
    SMTP_PASS = ""
    
    #Fromɥ쥹˰ʲɽޤޤϽǡʥ롼ɻߡ
    EXCLUDE_ADDRS = [/Mail\sDelivery\sSystem/, /rcode\.jp/]
    
    #editorial reviewsɽ
    E_REVIEW_CNT_MAX = 1
    #editorial reviewΥȤɽʸ
    E_REVIEW_LENGTH_MAX = 500
    #customer reviewsɽ
    C_REVIEW_CNT_MAX = 3
    #customer reviewΥȤɽʸ
    C_REVIEW_LENGTH_MAX = 500
    #similarity() ɽ
    SIMILARITY_CNT_MAX = 3
    
    #̾Υӥ塼륢ɥ쥹@ޡ
    FUNC_ADDRS_DEFAULT = [/b\@/]
    #ûӥ塼륢ɥ쥹@ޡ
    FUNC_ADDRS_PETIT = [/p\@/]
        
    ########################  ޤ   ########################
        
    LOG_DIRECTORY  = PROGRAM_DIRECTORY + "/log"
    LOG_MAIN = LOG_DIRECTORY + "/log.txt"
    LOG_DEBUG = LOG_DIRECTORY + "/log_debug.txt"


    DEFAULT_SUBJECT = "Subject: BarcodeReview\n\n"
    DEFAULT_ERROR_SUBJECT = "Subject: Error: BarcodeReview\n\n"
    DEFAULT_ERROR_MESSAGE =
              "Amazon Web Service(AWS)³˥顼ȯޤ\n" +
              " -Сֹ椬ǧƤ"
        
    #饹ν
    def initialize
      $LOAD_PATH.unshift(PROGRAM_DIRECTORY)
    
      require "util"
      require "barcode"
      require "item"
      require "search"

      @smtp_server = SMTP_SERVER
      @smtp_helo = SMTP_HELO
      @smtp_user = SMTP_USER
      @smtp_pass = SMTP_PASS
    
      @amazon_id = AMAZON_ID
      @amazon_token = AMAZON_TOKEN
    
      @log_main = LOG_MAIN
            
      @barcode_str = ""; 
      @user_addr = ""; 
      @func_addr = ""
      @func_mode = ""; 
      @header_error_message = ""; 
      @error_flag = false
      @exit_flag = false
    
      @user_device = UserDevice::OTHER 

      util = Util.new(DEBUG, $KCODE, LOGGING)
    end

    #ᥤ
    def main
      begin
        if(DEBUG)
          @file = File.new(LOG_DEBUG, "w")
          @file.flock(File::LOCK_EX)
          $> = @file
        end
        
        parse_header
        
        barcode = Barcode.new(@barcode_str)
        
        a_search = Search.new(@amazon_id, @amazon_token)
        a_search.search(barcode)
        body = format_body(a_search.item, a_search.error_message)
        
        send_mail(body)
        save_log
      rescue => e
        Util.puts_debug(e) 
      ensure
        if(DEBUG)
          @file.flock(File::LOCK_UN)
          @file.close()
        end
      end 
    end
    
    #إåΥѡ
    def parse_header
      m = Mail.new(STDIN.to_io)

      @barcode_str = parse_barcode(m['Subject'])
      @user_addr = parse_addr(m['From'])
      @func_addr = parse_addr(m['To'])
      @user_device = parse_device(m['Received'])
      if(!@barcode_str || @barcode_str.empty?)
        @barcode_str = parse_barcode(m.body[0])
      end
      
      #桼ƥΥ᡼륢ɥ쥹Сֹ椬ʤץཪλ
      raise "Invalid User Address"  unless(valid_user?)   
      raise "Invalid Function Address" unless(valid_func?)
      raise "Invalid Barcode Number" unless(valid_barcode?)  
         
      return
    end 
    
    #᡼Υեޥå
    def format_body(item, error)
      body = ""
      if(item == nil)
        body = DEFAULT_ERROR_MESSAGE
        @error_flag = true
        if(error != "" )
          body = body + "\n--(ʲAWSΥ顼ϤǤ)\n" + error
        else
          body = body + "[" + @barcode_str.to_s + "]" 
        end
      else
        begin
         item.user_device = @user_device
         item.func_mode = @func_mode
         body = item.to_s
        rescue  
         Util.puts_debug($!)
        end
      end
      return body
    end

    #᡼
    def send_mail(body)
      mail_body = format_header(body) 
                        
      if(@smtp_user != "" && @smtp_pass != "")
        Net::SMTP.start(@smtp_server,25,@smtp_helo,@smtp_user, 
                              @smtp_pass, :cram_md5){|smtp|
          smtp.send_mail(mail_body,@func_addr.to_s,@user_addr.to_s)
        }
      else
        Net::SMTP.start(@smtp_server,25,@smtp_helo){|smtp|
          smtp.send_mail(mail_body,@func_addr.to_s,@user_addr.to_s)
        }
      end
    end
    
    #¸
    def save_log
      @barcode_str = "nil" if(@error_flag)
      log_str = Util.format_log(@user_addr.to_s, @func_mode, @barcode_str)
      #Util.puts_debug("log:" + log_str)
      Util.write_to_file(@log_main, log_str, true) 
    end

  
  ########################֥롼#################################

    #Сֹ
    def parse_barcode(line)#,subject
      line =~ /^(\d+[xX]*)$/  #Сֹ
      barcode_str = $1
      return barcode_str
    end
    
    #᡼륢ɥ쥹
    def parse_addr(line)
      line.strip!
      line =~ /\<(.+)\>/         #-> Koji Tsukada <tsuka@example.com>
      if($1 != nil && $1 != "")
        addr = $1
      else
        if(line != nil)
          addr = line          
          addr = addr.split(',')[0]
        end
      end
      #Util.puts_debug(line)
      #Util.puts_debug(addr)
      return addr
    end
    
    #᡼إåReceivedѤơüμ̤Ƚ
    def parse_device(line)
      user_device = UserDevice::OTHER
      case(line)
        when(/docomo\.ne\.jp/)
          user_device = UserDevice::DOCOMO
        when(/ezweb\.ne\.jp/)
          user_device = UserDevice::AU
        when(/vodafone\.ne\.jp/)
          user_device = UserDevice::VODAFONE
      end
      return user_device
    end
    
    #ʥСֹå
    def valid_barcode?
      if(@barcode_str == nil || @barcode_str == "")
        @exit_flag = true
        return false
      elsif(@barcode_str =~ /[^0-9xX]/)    #إåʸ󤬤нλ
        @exit_flag = true
        return false
      else
        return true
      end
    end
    
    #ʥ桼ɥ쥹å
    def valid_user?
      if(!(@user_addr =~ /(.+)\@(.+)/)) 
        @exit_flag = true
        return false
      else
        EXCLUDE_ADDRS.each do |exclude|
          if(@user_addr =~ exclude) 
            @exit_flag = true
            return false
          end
        end
        return true
      end
    end
    
    #ƥॢɥ쥹å
    def valid_func?
      
      FUNC_ADDRS_DEFAULT.each do |addr|
        if(@func_addr =~ addr) 
          @func_mode = FuncMode::DEFAULT
          return true
        end
      end
      
      FUNC_ADDRS_PETIT.each do |addr|
        if(@func_addr =~ addr) 
          @func_mode = FuncMode::PETIT
          return true
        end
      end
      
      return false
               
    end
    
    #᡼
    def format_header(body)
      subject = ""
      if(!@error_flag)
        subject = DEFAULT_SUBJECT
      else
        subject = DEFAULT_ERROR_SUBJECT  
      end
          
       mail_body =   
            "From: <"+ @func_addr.to_s + ">\n" + 
            "To: <" + @user_addr.to_s + ">\n" + 
            "Content-Type: text/plain; charset=\"ISO-2022-JP\"\n" + 
            "Content-Transfer-Encoding: 7bit\n" + 
            subject + body +  "\n" + 
            "----\n" + 
            ":   <" + @func_addr.to_s + ">\n" +
            "Ȥ: <" + "http://" + @smtp_server.to_s + ">\n"
       Util.puts_debug(mail_body)
       mail_body = Util.convert_to_jis(mail_body)
    end

  end##BarcodeReview饹λ
  
  class FuncMode
    DEFAULT = "Default"
    PETIT = "Petit"
    DEBUG = "Debug"
  end
    
  class UserDevice
    DOCOMO = "docomo"
    VODAFONE = "vodafone"
    AU = "au"
    OTHER = "other"
  end


#########################ץΥȥݥ##########################
  #饹
  barcode_review = BarcodeReview.new
  barcode_review.main
end
