#  Copyright (C) 2004 Koji Tsukada
#      All rights reserved.
#      This is free software with ABSOLUTELY NO WARRANTY.
#
#  You can redistribute it and/or modify it under the terms of
#  the GNU General Public License version 2.

module BarcodeReview
  class Item
    attr_reader(:code_type, :code_id, :asin, :title, :search_index,
                  :author, :artist, :composer, :actor, :director, 
                  :publisher, :music_label, :label, :brand, :studio, :orchestra, 
                  :manufacturer, :release_date, :publication_date,
                  
                  :list_price,:lowest_new_price, :lowest_used_price,
                  :editorial_reviews, :average_rating, :total_reviews,
                  :customer_reviews, :similar_products, 
                  :image_url_small, :image_url_large, :detail_url, :sales_rank,
                  :user_device, :func_mode)
    attr_writer(:code_type, :code_id, :asin, :title, :search_index,
                  :author, :artist, :composer, :actor, :director, 
                  :publisher, :music_label, :label, :brand, :studio, :orchestra, 
                  :manufacturer, :release_date, :publication_date,
                  :list_price,:lowest_new_price, :lowest_used_price,
                  :editorial_reviews, :average_rating, :total_reviews,
                  :customer_reviews, :similar_products, 
                  :image_url_small, :image_url_large, :detail_url, :sales_rank,
                  :user_device, :func_mode)

    def initialize(type)
      @code_type = type
      @code_id = ""
      @search_index = ""
      
      @asin = ""
      @title = ""
      
      @author = ""
      @artist = ""
      @composer = ""
      @orchestra = ""
      @actor = ""
      @director = ""
      
      @publication_date = ""
      @release_date = "" #dvd, game,music
      
      @publisher = ""
      @studio = ""
      @music_label = ""
      @label = ""
      @brand = ""
      @manufacturer =""
      
      @list_price = ""
      @lowest_new_price = ""
      @lowest_used_price = ""
     
      @editorial_reviews = Array.new
      
      @average_rating = ""
      @total_reviews = ""
      
      @customer_reviews = Array.new
      @similar_products = Array.new
      
      @image_url_small = ""
      @image_url_large = ""
      
      @detail_url = ""
      @sales_rank = ""
      
      time = Time.now
      @search_date = time.year.to_s + "-" + time.month.to_s + "-" + time.day.to_s
      @user_device = ""
      @func_mode = ""
    end
  
    #ʸɲ
    def add_str(prefix, value, postfix="")
      if(value != nil && value != "")
        @str = @str + (prefix + value + postfix)
      end
    end

    #ƽ  
    def to_s
      @str = ""
      #Util.puts_debug("s")
      if(@code_type == Barcode::Type::OTHER)
          add_str("ɼ: ", @code_type.to_s)
          add_str("[", @code_id.to_s, "]")
          add_str("\n", "Сɼ̤Ƚ˼Ԥޤ.")
          return str
      end 
      
      add_str("ɼ: ", @code_type.to_s)
      add_str("[", @code_id.to_s, "]\n")
      
      Util.puts_debug("code")
            
      if(@code_type == Barcode::Type::ISBN)
        add_str("\n̾: ", @title)
        add_str("\n: ", @author)
        add_str("\nǼ: ", @publisher)
        add_str("\nȯ: ", @publication_date)
      else   
        case @search_index
         when "DVD", "Video", "VHS"
           add_str("\nȥ: ", @title)
           add_str("\nб: ", @actor)
           add_str("\n: ", @director)
           add_str("\n: ", @studio)
           add_str("\n: ", @publisher)
           add_str("\nȯ: ", @release_date)
         when "Music" 
           add_str("\nȥ: ", @title)
           add_str("\nƥ: ", @artist)
           add_str("\n졼٥: ", @music_label)
           add_str("\n졼٥: ", @label)
           add_str("\nȯ: ", @release_date)
         when "Classical"
           add_str("\nȥ: ", @title)
           add_str("\n: ", @artist)
           add_str("\n: ", @composer)
           add_str("\nȥ: ", @orchestra)
           add_str("\n졼٥: ", @music_label)
           add_str("\n졼٥: ", @label)
         when "Software", "VideoGames"
           add_str("\nȥ: ", @title)
           add_str("\n᡼: ", @publisher)
           add_str("\nȯ: ", @release_date)
         when "Electronics"
           add_str("\nȥ: ", @title)
           add_str("\n᡼: ", @manufacturer)
           add_str("\nȯ: ", @release_date)
        end
      end   
      
      #Util.puts_debug("info")
      
      add_str("\n\n: " , @list_price)
      add_str("\nʲ: ", @lowest_new_price, "")
      add_str("\nŲ: ", @lowest_used_price, "")  
      add_str("\n: " , @sales_rank)
      if(@lowest_new_price !="" || @lowest_used_price !="")
        add_str("\nʤ" , @search_date, "ߡ")
      end
 
      Util.puts_debug("price")
      if(@func_mode != FuncMode::PETIT)
        add_str("", "\n") if(@editorial_reviews.length > 0)
        cnt = 1
        @editorial_reviews.each do |review|
          if(review != "")
            review = Util.jtrim(review, BarcodeReview::E_REVIEW_LENGTH_MAX)
            add_str("\nԽԥӥ塼[" + cnt.to_s + "]: ", review)
            cnt += 1
            break if (cnt > BarcodeReview::E_REVIEW_CNT_MAX)
          end
        end
      end
   
      #Util.puts_debug("er")
   
      add_str("\n\nʿɾ: " , @average_rating, "/5")
      add_str("\nӥ塼: " , @total_reviews)
     
      if(@func_mode != FuncMode::PETIT)
        cnt = 1
        @customer_reviews.each do |c_review|
          if(c_review != nil) 
            add_str("\n\nӥ塼[" , cnt.to_s, "]: ")
            add_str("" , c_review.summary)
            add_str("\nɾ: " , c_review.rating, "/5")
            add_str("\n: " , c_review.date)
            if(c_review.helpful_votes != "")
              add_str("\n ӥ塼˻Ʊ: ", c_review.helpful_votes)
              add_str("/", c_review.total_votes)
            end
          
            if(c_review.content != "")
              c_review.content = 
                Util.jtrim(c_review.content, BarcodeReview::C_REVIEW_LENGTH_MAX)
              add_str("\n ʸ: ", c_review.content)
            end
            cnt += 1
            break if (cnt > BarcodeReview::C_REVIEW_CNT_MAX)
          end
        end
      else
        add_str("\n", "ӥ塼ϲܺ٤.") if(@customer_reviews.length > 0)
      end
      
      #Util.puts_debug("s")
      
      if(@func_mode != FuncMode::PETIT)
        add_str("", "\n")
        Util.puts_debug(@similar_products.length.to_s)
        if(@similar_products != nil && @similar_products.length > 0)
          add_str("\n", ": ")
        end
        
        cnt = 1
        @similar_products.each do |similar| 
          if(similar != nil)
            if(similar.title != "" || similar.asin != "")
              add_str("\n -", similar.title)
              add_str("[", similar.asin, "]")
              cnt += 1
              break if(cnt > BarcodeReview::SIMILARITY_CNT_MAX) 
            end
          end
        end
      end

      add_str("", "\n")
      
      url_docomo = "http://www.amazon.co.jp/gp/aw/d.html?uid=NULLGWDOCOMO&a="
      url_au    =  "http://www.amazon.co.jp/gp/aw/d.html?a="
      url_vodafone = "http://www.amazon.co.jp/gp/aw/d.html?a="

      case(@user_device)
        when(UserDevice::DOCOMO)
          add_str("\nܺ: ", url_docomo + @asin)
        when(UserDevice::AU)
          add_str("\nܺ: ", url_au + @asin)
        when(UserDevice::VODAFONE)
          add_str("\nܺ: ", url_vodafone + @asin)
        else
          add_str("\nܺ: ", @detail_url)
      end
      
       Util.puts_debug(@user_device)
      
      add_str("", "\n")
      return @str
    end   
    class CustomerReview   
      def initialize
        @asin = ""
        @rating = ""
        @helpful_votes = ""
        @total_votes = ""
        @date = ""
        @summary = ""
        @content = ""
      end
      
      attr_reader(:asin, :rating, :helpful_votes, :total_votes, :date, 
                  :summary, :content)
      attr_writer(:asin, :rating, :helpful_votes, :total_votes, :date, 
                  :summary, :content)
    end
  
  
    class SimilarProduct
      def initialize
        @asin = ""
        @title = ""
      end
      attr_reader(:asin, :title)
      attr_writer(:asin, :title)
    end
  end
end
