#  Copyright (C) 2004 Koji Tsukada
#      All rights reserved.
#      This is free software with ABSOLUTELY NO WARRANTY.
#
#  You can redistribute it and/or modify it under the terms of
#  the GNU General Public License version 2.

require "rexml/document"
require "socket"
require "net/http"

require "barcode"
require "item"
require "util"

module BarcodeReview
  #ޥ󸡺Ԥ饹
  class Search
    attr_reader(:error_message, :item)
    attr_writer(:item)
    def initialize(amazon_id, amazon_token)
      @amazon_id = amazon_id.to_s
      @amazon_token = amazon_token.to_s
      @error_message = ""
    end
    
    def connect(host, query)
      xdoc = nil
      Net::HTTP.version_1_2
      Net::HTTP.start(host, 80) {|http|
        response = http.get(query) 
        xdoc = REXML::Document.new(response.body)
      }
      return xdoc
    end

    #AWSѤƥСֹ򸡺
    def search(bar)
      if(@amazon_id == "" || @amazon_token == "")
        Util.puts_debug("ޥID/Subscription IDϤƤޤ [" +
                        @amazon_id + "," + @amazon_token + "]") 
        return
      end

      type = bar.type
      barcode = bar.barcode
            
      hosts = Array.new(["webservices.amazon.co.jp",
                               "webservices.amazon.com"])      
      query = 
          "/onca/xml?Service=AWSECommerceService&" + 
          "SubscriptionId=" + @amazon_token + "&" + "AssociateTag=" +
          @amazon_id + "&" + "Operation=ItemLookup&" +
          "ResponseGroup=Medium,Reviews,Similarities&" +
          "Condition=All&MerchantId=All&"

      si_prefix = "SearchIndex="
      si_values = Array.new(["Music", "DVD", "Electronics", "Software", 
                    "VideoGames", "Classical", "VHS", "Video"])

      xdoc = nil
    
      if(type == Barcode::Type::ISBN)
        Util.puts_debug("ISBN")    
        option = "IdType=ASIN&ItemId="
        hosts.each {|host| 
          xdoc = connect(host, query + option + barcode);
          if(!parse_error(xdoc))
            parse_xml(xdoc, type)
            Util.puts_debug("end")    
            return
          end
        }
      elsif(type == Barcode::Type::UPC)          
        Util.puts_debug("UPC")
        option = "&IdType=UPC&ItemId="
        #for i in 0...si_values.length
        si_values.each {|si_value|         
          xdoc = connect(hosts[1], query + si_prefix + si_value + option + barcode)
          if(!parse_error(xdoc))
            parse_xml(xdoc, type)
            return
          end  
        }
      elsif(type == Barcode::Type::EAN)
        Util.puts_debug("EAN")
        option = "&IdType=EAN&ItemId="
        si_values.each {|si_value|
          xdoc = connect(hosts[0], query + si_prefix + si_value + option + barcode)
          if(!parse_error(xdoc))
            parse_xml(xdoc, type)
            return
          end  
        }
      elsif (type == Barcode::Type::OTHER)
        Util.puts_debug("Other: " + barcode.to_s)
        @error_message = "СɤμबǧǤޤ"
        Util.puts_debug(@error_message)
      end
      return
    end
    
    #AWSΥ顼
    def parse_error(xdoc)  
      prefix = "/ItemLookupResponse/Items/Request/"
      error = "Errors/Error/"
      
      if(xdoc.elements[prefix + error + "Code"] != nil)
        @error_message = xdoc.text(prefix + error + "Code") + 
                            "\n" + xdoc.text(prefix + error + "Message")
        @error_message = Util.convert_from_u8(@error_message)
        return true
      elsif(xdoc.text(prefix + "IsValid") == "False")
        @error_message = "Amazon Web Service³˥顼ȯޤ."
        return true
      else
        return false
      end    
    end
     
    #AWSθ̤Item饹˳Ǽ
    def parse_xml(xdoc, type)
      item = Item.new(type)
      
      Util.puts_debug(Util.convert_from_u8(xdoc.to_s))

      begin      
        arg = "/ItemLookupResponse/OperationRequest/Arguments/Argument"
        prefix = "/ItemLookupResponse/Items/Item/"
        attr = "ItemAttributes/"
        
        item.code_id =      get_attr(xdoc, arg, "ItemId")
        item.search_index = get_attr(xdoc, arg, "SearchIndex")
               
        item.asin  =        get_str(xdoc, prefix + "ASIN")
        item.title =        get_str(xdoc, prefix + attr + "Title")       
        item.author =       get_str(xdoc, prefix + attr + "Author")
        item.artist =       get_str(xdoc, prefix + attr + "Artist")
        item.composer =     get_str(xdoc, prefix + attr + "Composer")
        item.orchestra =    get_str(xdoc, prefix + attr + "Orchestra")
        item.actor =        get_str(xdoc, prefix + attr + "Actor")
        item.director =     get_str(xdoc, prefix + attr + "Director")
        item.publisher =    get_str(xdoc, prefix + attr + "Publisher")
        item.studio =       get_str(xdoc, prefix + attr + "Studio")
        item.music_label = get_str(xdoc, prefix + attr + "MusicLabel")
        item.label =        get_str(xdoc, prefix + attr + "Label")
        item.brand =        get_str(xdoc, prefix + attr + "Brand")
        item.manufacturer = get_str(xdoc, prefix + attr + "Manufacturer")
        item.image_url_small = get_str(xdoc, prefix + "MediumImage/URL")
        item.image_url_large = get_str(xdoc, prefix + "LargeImage/URL")
        item.detail_url =       get_str(xdoc,  prefix + "DetailPageURL")        
        item.sales_rank =       get_str(xdoc, prefix + "SalesRank")
        item.publication_date = get_str(xdoc, prefix + attr + "PublicationDate")
        item.release_date =     get_str(xdoc, prefix + attr + "ReleaseDate")
        item.list_price =       
          get_str(xdoc, prefix + attr + "ListPrice/FormattedPrice")
        item.lowest_new_price = 
          get_str(xdoc, prefix + "OfferSummary/LowestNewPrice/FormattedPrice")
        item.lowest_used_price = 
          get_str(xdoc, prefix + "OfferSummary/LowestUsedPrice/FormattedPrice")
        item.average_rating =
          get_str(xdoc, prefix + "CustomerReviews/AverageRating")
        item.total_reviews =
          get_str(xdoc, prefix + "CustomerReviews/TotalReviews")
        item.editorial_reviews = 
          get_ereview(xdoc, prefix + "EditorialReviews/EditorialReview/Content")
        item.customer_reviews =
          get_creview(xdoc, prefix + "CustomerReviews/Review/")
        item.similar_products = 
          get_similar(xdoc, prefix + "SimilarProducts/SimilarProduct/")

        @item = item        
      rescue
        Util.puts_debug($!)
        @error_message
      end
    end 

    
    def get_attr(xdoc, node, name)
      text = ""
      elements = xdoc.get_elements(node)
      elements.each do |e|
        if(name == e.attributes["Name"])
          text = e.attributes["Value"]
          text = Util.convert_from_u8(text)
          break
        end
      end 
      return text
    end
   
    def get_str(xdoc, node)
      text = ""
      elements = xdoc.get_elements(node)
      if(elements != nil)
        text = Util.connect_array(elements)
        text = Util.convert_from_u8(text)
      end
      return text
    end
    
    def get_ereview(xdoc, node)  
      elements = xdoc.get_elements(node)
      array = Array.new
      if(elements != nil)        
        elements.each do |element|
          next if(element == nil)
          r_text = Util.convert_from_u8(element.text)
          r_text = Util.delete_html_tags(r_text)
          array.push(r_text)
        end
      end
      return array
    end
    
    def get_creview(xdoc, node)
      elements = xdoc.get_elements(node)
      array = Array.new
      if(elements != nil)
        elements.each do |element|
          next if(element == nil)
  
          c_review = Item::CustomerReview.new()
          c_review.asin =          get_str(element, "ASIN")
          c_review.rating =        get_str(element,  "Rating")
          c_review.helpful_votes = get_str(element, "HelpfulVotes")
          c_review.total_votes =   get_str(element, "TotalVotes")
          c_review.date =          get_str(element, "Date")
          c_review.summary =       get_str(element, "Summary")
          c_review.content =       get_str(element, "Content")
          c_review.content =       Util.delete_html_tags(c_review.content)
                   
          array.push(c_review)
        end 
      end
      return array
    end
    
    def get_similar(xdoc, node)
      elements = xdoc.get_elements(node)
      array = Array.new
      if(elements != nil)
        elements.each do |element|
          next if(element == nil)
          s_product =       Item::SimilarProduct.new()
          s_product.asin  =  get_str(element, "ASIN")
          s_product.title = get_str(element, "Title")
          array.push(s_product)
        end      
      end
      return array
    end

  end
end
