#  Copyright (C) 2004 Koji Tsukada
#      All rights reserved.
#      This is free software with ABSOLUTELY NO WARRANTY.
#
#  You can redistribute it and/or modify it under the terms of
#  the GNU General Public License version 2.

require "uconv"
require "nkf"
require "digest/md5"
require "rexml/document"

module BarcodeReview
  #ʸѴǡ¸ʤɤԤ饹
  class Util
    def initialize(debug, kcode, logging)
      @@debug = debug
      if(kcode =~ /^(e|E)/)
        @@kcode_euc = true
        #self.puts_debug("euc")
      else
        @@kcode_euc = false
        #self.puts_debug("sjis")
      end
      @@logging = logging 
    end
      
    #ǥХåν
    def self.puts_debug(str)
      puts(str) if(@@debug)
    end
    
    #ǡե¸
    def self.write_to_file(file_str, str, add_flag=false)
      return if(!@@logging)
      
      begin
        if(add_flag)
          file = File.new(file_str, "a")
        else
          file = File.new(file_str, "w")
        end
        file.flock(File::LOCK_EX)
        file.write(str)
        rescue
          self.puts_debug($! ) 
        ensure
          file.flock(File::LOCK_UN)
          file.close()
      end
    end
    
    #¸
    def self.format_log(email, mode, id)
      result = ""
      mode_str = ""
      case(mode)
        when(FuncMode::DEFAULT)
          mode_str = "b"
        when(FuncMode::PETIT)
          mode_str = "p"
        else
          mode_str = "b"
      end
             
      email =~  /(.+)\@(.+)/ 
      user_str = $1
      domain = $2
      user_md5 = Util.convert_to_md5(user_str)
      t = Time.now
      t_str = t.year.to_s + "/" + t.month.to_s + 
                        "/" + t.day.to_s + " " + t.hour.to_s + ":" + 
                        t.min.to_s + ":" + t.sec.to_s
      #self.puts_debug("md5:" + user_str + ", " + user_md5.to_s)
      result = user_md5.to_s + "\@" + domain.to_s + "\t" + 
                id.to_s + "\t" +  mode_str + "\t" + t_str + "\n"
      return result
    end

    #UTF8EUC/SJISѴ
    def self.convert_from_u8(str)
      begin
        if(@@kcode_euc)
          result = Uconv.u8toeuc(str)
        else
          result = Uconv.u8tosjis(str)
       end
      rescue
        result = ""
      end
      return result
    end
    
    #EUC/SJIS顤JISѴ
    def self.convert_to_jis(str)
      if(@@kcode_euc)
        result = NKF.nkf("-jE", str); 
      else
        result = NKF.nkf("-jS", str)
      end
      return result
    end
    
    #ʸHTMLõ
    def self.delete_html_tags(str)
      result = str
      result = result.gsub('', '')
      result = result.gsub(/(\n|\r)/, '')
      result = result.gsub(/\&nbsp\;/,'')
      result = result.gsub(/\&lt\;/, "<")
      result = result.gsub(/\&rt\;/, ">")
      result = result.gsub(/\<(p|br)\>/i, "\n")
      result = result.gsub(/\<(\/|\d|\w)+\>/,'')
      return result
    end
    
    #Ĥʸ³
    def self.connect_array(xml_elements)
      result = ""
      xml_elements.each do |element|
        if(result == "")
          result = element.text
        else
          result = result + "," + element.text
        end
      end
      return result
    end
    
    def self.convert_to_md5(str)
      result = Digest::MD5.hexdigest(str)
      return result
    end

    #ʸλˤ
    def self.jtrim(str, max)
      if(str.length > max)
        str = str.slice(0, max)
        if(str[max-1, 1] !~ /./)
          str[max-1, 1] = ""
        end
        str = str +  "..."      
      end
      
      return str
  end


  end
end
